package com.lzmispt.data.resource.service.log.impl;

package .tmp;

import com.lzmispt.core.entity.dto.listdeletemodel.ListDeleteModelDTO;
import com.lzmispt.core.service.listdelete.ListDeleteUtil;
import com.lzmispt.data.center.entity.dto.querymodel.DCQueryModelDTO;
import com.lzmispt.data.center.entity.po.LogPO;
import com.lzmispt.data.center.entity.vo.LogVO;
import com.lzmispt.data.resource.dao.log.ILogDao;
import com.lzmispt.data.resource.service.log.ILog;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.database.IManage;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.CollectionUtils;

public abstract class LogManager implements ILog, IManage {
  @Value("${data-center.data-mode:mysql}")
  private String dbType;
  
  public ResultEntity<Map> getLogList(DCQueryModelDTO queryModelDTO) {
    Map<Object, Object> resultMap = new HashMap<>();
    List<Long> logIds = ((ILogDao)ServiceUtil.getLogDao(getDefaultCode(), ILogDao.class)).selectIdsByQueryModel(queryModelDTO);
    if (!CollectionUtils.isEmpty(logIds)) {
      List<LogPO> logPOList = ((ILogDao)ServiceUtil.getLogDao(getDefaultCode(), ILogDao.class)).selectLogByIds(logIds);
      List<LogVO> logVOList = new ArrayList<>();
      if (logPOList != null) {
        for (int i = 0; i < logIds.size(); i++) {
          LogVO logVO = new LogVO();
          logVO.setId(logIds.get(i));
          logVOList.add(logVO);
        } 
        for (LogVO logVO : logVOList) {
          for (LogPO logPO : logPOList) {
            if (logPO.getId().equals(logVO.getId()))
              BeanUtils.copyProperties(logPO, logVO); 
          } 
        } 
      } 
      int total = ((ILogDao)ServiceUtil.getLogDao(getDefaultCode(), ILogDao.class)).selectTotalLogList(queryModelDTO);
      resultMap.put("data", logVOList);
      resultMap.put("total", Integer.valueOf(total));
    } else {
      resultMap.put("data", new ArrayList());
      resultMap.put("total", Integer.valueOf(0));
    } 
    return ResultEntity.successMessage(resultMap);
  }
  
  public ResultEntity<Boolean> delLogByIds(ListDeleteModelDTO listDeleteModelDTO, String tokenId) {
    ResultEntity<String> result = ListDeleteUtil.getListDeleteWhere(listDeleteModelDTO, this.dbType);
    if (!result.getCode().equals(DCConst.FALSE))
      return ResultEntity.errorMessage(result.getCode(), result.getMsg()); 
    ((ILogDao)ServiceUtil.getLogDao(getDefaultCode(), ILogDao.class)).delLogByIds((String)result.getObj());
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  public ResultEntity<LogVO> getLogById(Long id, String tokenId) {
    LogPO logPO = ((ILogDao)ServiceUtil.getLogDao(getDefaultCode(), ILogDao.class)).selectLogById(id);
    LogVO logVO = new LogVO();
    BeanUtils.copyProperties(logPO, logVO);
    return ResultEntity.successMessage(logVO);
  }
  
  public ResultEntity<LogVO> getLogByOperationMark(String operationMark, String tokenId) {
    LogPO logPO = ((ILogDao)ServiceUtil.getLogDao(getDefaultCode(), ILogDao.class)).getLogByOperationMark(operationMark);
    if (logPO == null)
      return ResultEntity.successMessage(null); 
    LogVO logVO = new LogVO();
    BeanUtils.copyProperties(logPO, logVO);
    return ResultEntity.successMessage(logVO);
  }
}
